> For the complete documentation index, see [llms.txt](https://developer.emporix.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.emporix.io/api-documentation/api-guides/companies-and-customers/customer-service/api-reference/import-and-migration.md).

# Import And Migration

## Retrieving password migration retention configuration

> Retrieves the password migration retention configuration for the tenant.

```json
{"openapi":"3.0.0","info":{"title":"Customer Service (tenant-managed)","version":"0.0.1"},"tags":[{"name":"Import and migration"}],"servers":[{"url":"https://api.emporix.io"}],"security":[{"OAuth2":["customer.import_read"]}],"components":{"securitySchemes":{"OAuth2":{"type":"oauth2","flows":{"clientCredentials":{"refreshUrl":"","scopes":{"customer.customer_read":"Needed to retrieve customer profiles.","customer.customer_read_own":"Needed by customer to retrieve customer profiles from the same company.","customer.customer_manage":"Needed to manage customer profiles.","customer.customer_manage_own":"Needed by customer to manage customer profiles from the same company.","customer.import_read":"Needed to retrieve password migration retention configuration.","customer.import_manage":"Needed to configure password migration retention and import customers in bulk."},"tokenUrl":"https://api.emporix.io/oauth/token"}}}},"schemas":{"PasswordMigrationRetentionConfigResponse":{"type":"object","properties":{"retentionEndDate":{"type":"string","format":"date","description":"Date when the password migration retention window ends."},"emailReminderDate":{"type":"string","format":"date","description":"Date when reminder emails are sent to unmigrated customers."},"emailNotificationsEnabled":{"type":"boolean","description":"Flag indicating whether customers receive email notifications about the migration process.\nWhen `true`, customers receive reminder and password reset emails. When `false`, customers do not receive any emails regarding the migration.\n"}}},"ErrorMessage":{"title":"","description":"Schema for API-specific errors.","type":"object","properties":{"status":{"minimum":100,"maximum":599,"description":"Original HTTP error code. It should be consistent with the HTTP response code.","type":"integer"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `validation_failure`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."},"details":{"description":"List of problems causing the error.","type":"array","items":{"title":"errorDetail","description":"Specific error cause.","type":"object","properties":{"field":{"description":"Element in request data which is causing the error, for example `category.name`.\nIf the violation was not field-specific, this field will be empty.","type":"string"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the specific error cause. This value should always be interpreted within the context of the general error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `missing_value`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."}}}}}}},"responses":{"401_unauthorized":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"fault":{"type":"object","properties":{"faultstring":{"type":"string"},"detail":{"type":"object","properties":{"errorcode":{"type":"string"}}}}}}}}}},"403_forbidden":{"description":"Given authorization scopes are not sufficient and do not match scopes required by the endpoint.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}}},"paths":{"/customer/{tenant}/config/password-migration-retention":{"get":{"summary":"Retrieving password migration retention configuration","operationId":"GET-customer-tenant-retrieve-password-migration-retention","tags":["Import and migration"],"description":"Retrieves the password migration retention configuration for the tenant.","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordMigrationRetentionConfigResponse"}}}},"401":{"$ref":"#/components/responses/401_unauthorized"},"403":{"$ref":"#/components/responses/403_forbidden"},"404":{"description":"Password migration retention configuration is not set for the tenant."}}}}}}
```

## Configuring password migration retention

> Creates or updates the password migration retention configuration for the tenant.\
> \
> Use this configuration before importing customers with \`legacyAuth\`.\
> For customers with \`legacyAuth\`, legacy password hashes are silently migrated to Emporix hashes on the first successful login.\
> When the retention period ends, remaining unmigrated accounts require a password reset and legacy credentials are cleared. A password reset email is sent to affected customers when \`emailNotificationsEnabled\` is \`true\`.\
> An email reminder requesting a single login is sent on \`emailReminderDate\` to all unmigrated customers when \`emailNotificationsEnabled\` is \`true\`, asking them to log in once so their accounts can be migrated.\
> \
> If \`emailReminderDate\` is omitted, the service defaults to 7 days before \`retentionEndDate\`, or to tomorrow when that default would fall on or before today.\
> If \`emailNotificationsEnabled\` is omitted, the service defaults to \`true\`. When \`false\`, customers do not receive any emails regarding the migration.\
> \
> If emails should include links to the storefront (password reset or login page), or a non-standard email template is required, please contact Emporix support.

```json
{"openapi":"3.0.0","info":{"title":"Customer Service (tenant-managed)","version":"0.0.1"},"tags":[{"name":"Import and migration"}],"servers":[{"url":"https://api.emporix.io"}],"security":[{"OAuth2":["customer.import_manage"]}],"components":{"securitySchemes":{"OAuth2":{"type":"oauth2","flows":{"clientCredentials":{"refreshUrl":"","scopes":{"customer.customer_read":"Needed to retrieve customer profiles.","customer.customer_read_own":"Needed by customer to retrieve customer profiles from the same company.","customer.customer_manage":"Needed to manage customer profiles.","customer.customer_manage_own":"Needed by customer to manage customer profiles from the same company.","customer.import_read":"Needed to retrieve password migration retention configuration.","customer.import_manage":"Needed to configure password migration retention and import customers in bulk."},"tokenUrl":"https://api.emporix.io/oauth/token"}}}},"schemas":{"PasswordMigrationRetentionConfigRequest":{"type":"object","required":["retentionEndDate"],"properties":{"retentionEndDate":{"type":"string","format":"date","description":"Future date when the password migration retention window ends."},"emailReminderDate":{"type":"string","format":"date","description":"Optional date on or after today and before `retentionEndDate` when reminder emails are sent to unmigrated customers.\nWhen omitted, defaults to 7 days before `retentionEndDate`, or to tomorrow when that default would fall on or before today.\n"},"emailNotificationsEnabled":{"type":"boolean","default":true,"description":"Optional flag indicating whether customers receive email notifications about the migration process.\nWhen `true`, customers receive reminder and password reset emails. When `false`, customers do not receive any emails regarding the migration.\nWhen omitted, defaults to `true`.\n"}}},"PasswordMigrationRetentionConfigResponse":{"type":"object","properties":{"retentionEndDate":{"type":"string","format":"date","description":"Date when the password migration retention window ends."},"emailReminderDate":{"type":"string","format":"date","description":"Date when reminder emails are sent to unmigrated customers."},"emailNotificationsEnabled":{"type":"boolean","description":"Flag indicating whether customers receive email notifications about the migration process.\nWhen `true`, customers receive reminder and password reset emails. When `false`, customers do not receive any emails regarding the migration.\n"}}},"ErrorMessage":{"title":"","description":"Schema for API-specific errors.","type":"object","properties":{"status":{"minimum":100,"maximum":599,"description":"Original HTTP error code. It should be consistent with the HTTP response code.","type":"integer"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `validation_failure`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."},"details":{"description":"List of problems causing the error.","type":"array","items":{"title":"errorDetail","description":"Specific error cause.","type":"object","properties":{"field":{"description":"Element in request data which is causing the error, for example `category.name`.\nIf the violation was not field-specific, this field will be empty.","type":"string"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the specific error cause. This value should always be interpreted within the context of the general error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `missing_value`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."}}}}}}},"responses":{"400_bad_request":{"description":"Request was syntactically incorrect. Details will be provided in the response payload.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}},"401_unauthorized":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"fault":{"type":"object","properties":{"faultstring":{"type":"string"},"detail":{"type":"object","properties":{"errorcode":{"type":"string"}}}}}}}}}},"403_forbidden":{"description":"Given authorization scopes are not sufficient and do not match scopes required by the endpoint.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}}},"paths":{"/customer/{tenant}/config/password-migration-retention":{"post":{"summary":"Configuring password migration retention","operationId":"POST-customer-tenant-configure-password-migration-retention","tags":["Import and migration"],"description":"Creates or updates the password migration retention configuration for the tenant.\n\nUse this configuration before importing customers with `legacyAuth`.\nFor customers with `legacyAuth`, legacy password hashes are silently migrated to Emporix hashes on the first successful login.\nWhen the retention period ends, remaining unmigrated accounts require a password reset and legacy credentials are cleared. A password reset email is sent to affected customers when `emailNotificationsEnabled` is `true`.\nAn email reminder requesting a single login is sent on `emailReminderDate` to all unmigrated customers when `emailNotificationsEnabled` is `true`, asking them to log in once so their accounts can be migrated.\n\nIf `emailReminderDate` is omitted, the service defaults to 7 days before `retentionEndDate`, or to tomorrow when that default would fall on or before today.\nIf `emailNotificationsEnabled` is omitted, the service defaults to `true`. When `false`, customers do not receive any emails regarding the migration.\n\nIf emails should include links to the storefront (password reset or login page), or a non-standard email template is required, please contact Emporix support.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordMigrationRetentionConfigRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordMigrationRetentionConfigResponse"}}}},"400":{"$ref":"#/components/responses/400_bad_request"},"401":{"$ref":"#/components/responses/401_unauthorized"},"403":{"$ref":"#/components/responses/403_forbidden"},"500":{"description":"Configuration could not be saved."}}}}}}
```

## Removing password migration retention configuration

> Removes the password migration retention configuration for the tenant.\
> \
> To avoid indefinite storage of potentially sensitive legacy password hashes, the configuration removal is blocked while any customer account still contains a \`legacyAuth\` record.\
> Complete the migration window first. The configuration may still be updated to move the \`retentionEndDate\` earlier and complete migration sooner.

```json
{"openapi":"3.0.0","info":{"title":"Customer Service (tenant-managed)","version":"0.0.1"},"tags":[{"name":"Import and migration"}],"servers":[{"url":"https://api.emporix.io"}],"security":[{"OAuth2":["customer.import_manage"]}],"components":{"securitySchemes":{"OAuth2":{"type":"oauth2","flows":{"clientCredentials":{"refreshUrl":"","scopes":{"customer.customer_read":"Needed to retrieve customer profiles.","customer.customer_read_own":"Needed by customer to retrieve customer profiles from the same company.","customer.customer_manage":"Needed to manage customer profiles.","customer.customer_manage_own":"Needed by customer to manage customer profiles from the same company.","customer.import_read":"Needed to retrieve password migration retention configuration.","customer.import_manage":"Needed to configure password migration retention and import customers in bulk."},"tokenUrl":"https://api.emporix.io/oauth/token"}}}},"schemas":{"ErrorMessage":{"title":"","description":"Schema for API-specific errors.","type":"object","properties":{"status":{"minimum":100,"maximum":599,"description":"Original HTTP error code. It should be consistent with the HTTP response code.","type":"integer"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `validation_failure`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."},"details":{"description":"List of problems causing the error.","type":"array","items":{"title":"errorDetail","description":"Specific error cause.","type":"object","properties":{"field":{"description":"Element in request data which is causing the error, for example `category.name`.\nIf the violation was not field-specific, this field will be empty.","type":"string"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the specific error cause. This value should always be interpreted within the context of the general error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `missing_value`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."}}}}}}},"responses":{"401_unauthorized":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"fault":{"type":"object","properties":{"faultstring":{"type":"string"},"detail":{"type":"object","properties":{"errorcode":{"type":"string"}}}}}}}}}},"403_forbidden":{"description":"Given authorization scopes are not sufficient and do not match scopes required by the endpoint.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}}},"paths":{"/customer/{tenant}/config/password-migration-retention":{"delete":{"summary":"Removing password migration retention configuration","operationId":"DELETE-customer-tenant-remove-password-migration-retention","tags":["Import and migration"],"description":"Removes the password migration retention configuration for the tenant.\n\nTo avoid indefinite storage of potentially sensitive legacy password hashes, the configuration removal is blocked while any customer account still contains a `legacyAuth` record.\nComplete the migration window first. The configuration may still be updated to move the `retentionEndDate` earlier and complete migration sooner.","responses":{"204":{"description":"No Content"},"400":{"description":"Configuration removal is not possible until password migration is concluded.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}},"401":{"$ref":"#/components/responses/401_unauthorized"},"403":{"$ref":"#/components/responses/403_forbidden"}}}}}}
```

## Importing customers in bulk

> Imports multiple customer profiles in a single request. The maximum batch size is 200.\
> \
> Each item must include an \`account\` object with exactly one of:\
> \* \`passwordHash\` — a precomputed password hash compatible with the Emporix password hashing strategy. In order to determine if your existing strategy is compatible, please contact Emporix support.\
> \* \`legacyAuth\` — a legacy password hash (incompatible with the Emporix password hashing strategy) and algorithm metadata for lazy rehash on first successful login. In order to establish the required algorithm metadata for your case, please contact Emporix support.\
> \
> To avoid indefinite storage of potentially sensitive legacy password hashes, importing customers with \`legacyAuth\` requires an active password migration retention configuration for the tenant.\
> \
> Response for a particular customer is returned at the same position (index) at which that customer is located in the request body.

```json
{"openapi":"3.0.0","info":{"title":"Customer Service (tenant-managed)","version":"0.0.1"},"tags":[{"name":"Import and migration"}],"servers":[{"url":"https://api.emporix.io"}],"security":[{"OAuth2":["customer.import_manage"]}],"components":{"securitySchemes":{"OAuth2":{"type":"oauth2","flows":{"clientCredentials":{"refreshUrl":"","scopes":{"customer.customer_read":"Needed to retrieve customer profiles.","customer.customer_read_own":"Needed by customer to retrieve customer profiles from the same company.","customer.customer_manage":"Needed to manage customer profiles.","customer.customer_manage_own":"Needed by customer to manage customer profiles from the same company.","customer.import_read":"Needed to retrieve password migration retention configuration.","customer.import_manage":"Needed to configure password migration retention and import customers in bulk."},"tokenUrl":"https://api.emporix.io/oauth/token"}}}},"schemas":{"CustomerImportDto":{"allOf":[{"$ref":"#/components/schemas/CustomerCreateDto"},{"type":"object","required":["account"],"properties":{"id":{"type":"string","description":"Custom customer identifier. If not provided, it is automatically generated.","minLength":1,"maxLength":66,"pattern":"^[\\w-]{1,66}$"},"contactEmail":{"type":"string","description":"Optional contact email. When provided, it must match `account.email` (case-insensitive).\nIf omitted, `account.email` is used as the contact email.\n"},"account":{"$ref":"#/components/schemas/CustomerImportAccountDto"}}}]},"CustomerCreateDto":{"type":"object","properties":{"title":{"type":"string"},"firstName":{"type":"string"},"middleName":{"type":"string"},"lastName":{"type":"string"},"contactPhone":{"type":"string"},"company":{"type":"string"},"preferredLanguage":{"type":"string","default":"en_US","description":"Customer preferred language."},"preferredCurrency":{"type":"string","default":"USD","description":"Customer preferred currency, compliant with the ISO 4217 standard.","minLength":3,"maxLength":3},"preferredSite":{"type":"string","default":"main","description":"Customer preferred site."},"type":{"type":"string","description":"User type. Supported values are: `CUSTOMER` and `CONTACT`. If the field is empty then the user is considered as a customer."},"photoUrl":{"type":"string","description":"Url of a picture."},"b2b":{"allOf":[{"$ref":"#/components/schemas/B2BCreate"}]},"metadata":{"$ref":"#/components/schemas/BasicMetadataDto"},"mixins":{"type":"object","description":"Customer account's additional properties. The property is not returned by default. In order to return the mixins property use `expand=mixin:*` query param.","additionalProperties":true},"restriction":{"$ref":"#/components/schemas/Restriction"}}},"B2BCreate":{"type":"object","description":"Additional properties for B2B customer.","properties":{"companyRegistrationId":{"type":"string","description":"Registration number of the company."}}},"BasicMetadataDto":{"title":"DefaultDtoMetadata","type":"object","properties":{"mixins":{"type":"object","additionalProperties":true}},"description":"Links to mixin schemas."},"Restriction":{"type":"string","nullable":true,"description":"Access control identifier that determines who can view or manage the customer.\n\n**Purpose**: Restricts customer visibility based on scope permissions. Only users/applications \nwith matching restriction scopes can access customers with a specific restriction value.\n\n**Access Control**:\n- *Reading*: Users can only query and view customers with the `restriction` value that matches one of their authorized restrictions.\n\n**Validation**: The value must exist in the tenant's configured list of valid restrictions.\n\n**Site Synchronization**: If the `restriction` property is not set with tenant configuration property `enableSyncBetweenRestrictionsAndSiteCodes` set to `true`, the `restriction` field automatically syncs with `preferredSite` property.\n"},"CustomerImportAccountDto":{"type":"object","required":["email"],"properties":{"email":{"type":"string","description":"Customer account email address. Used as the account identifier."},"passwordHash":{"type":"string","description":"Precomputed Emporix native password hash.\n\nProvide exactly one of `passwordHash` or `legacyAuth`.\nPlease, contact Emporix support to determine if your existing password hashing strategy is compatible with the Emporix native password hashing strategy.\n"},"legacyAuth":{"$ref":"#/components/schemas/LegacyAuth","description":"Legacy authentication data used for password migration.\n\nProvide exactly one of `passwordHash` or `legacyAuth`. Requires an active password migration retention configuration for the tenant.\n"}}},"LegacyAuth":{"type":"object","required":["algorithm","hash"],"properties":{"algorithm":{"type":"string","description":"Identifier of the legacy password verifier to use during login. Please, contact Emporix support to determine the correct value for your case.","enum":["hybris-sha512-uid-salt"]},"hash":{"type":"string","description":"Raw password hash exported from the source system. Stored only in `legacyAuth`, never in the native password field."},"context":{"type":"object","description":"Algorithm-specific metadata required for verification.\nPlease, contact Emporix support to determine the correct values for your case.\n","additionalProperties":{"type":"string"}}}},"CustomerBulkItemResponse":{"type":"object","properties":{"index":{"type":"integer","description":"Index of the processed item, matching the item position in the request body."},"id":{"type":"string","description":"Customer number generated for a successfully imported customer."},"code":{"type":"integer","description":"HTTP status code for the processed item."},"status":{"type":"string","description":"HTTP status description for the processed item."},"message":{"type":"string","description":"Error message when the item failed."},"details":{"type":"array","description":"List of problems causing the error.","items":{"type":"object","properties":{"message":{"type":"string"}}}}}},"ErrorMessage":{"title":"","description":"Schema for API-specific errors.","type":"object","properties":{"status":{"minimum":100,"maximum":599,"description":"Original HTTP error code. It should be consistent with the HTTP response code.","type":"integer"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `validation_failure`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."},"details":{"description":"List of problems causing the error.","type":"array","items":{"title":"errorDetail","description":"Specific error cause.","type":"object","properties":{"field":{"description":"Element in request data which is causing the error, for example `category.name`.\nIf the violation was not field-specific, this field will be empty.","type":"string"},"type":{"pattern":"[a-z]+[a-z_]*[a-z]+","description":"Classification of the specific error cause. This value should always be interpreted within the context of the general error type.\n**Note:** The error type should be written in lowercase and include underscores, for example `missing_value`.","type":"string"},"message":{"description":"Descriptive error message for debugging purposes.","type":"string"},"moreInfo":{"type":"string","description":"More information (such as a link to the documentation) for investigating further and getting support."}}}}}}},"responses":{"400_bad_request":{"description":"Request was syntactically incorrect. Details will be provided in the response payload.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}},"401_unauthorized":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"fault":{"type":"object","properties":{"faultstring":{"type":"string"},"detail":{"type":"object","properties":{"errorcode":{"type":"string"}}}}}}}}}},"403_forbidden":{"description":"Given authorization scopes are not sufficient and do not match scopes required by the endpoint.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}}},"paths":{"/customer/{tenant}/customers/import":{"post":{"summary":"Importing customers in bulk","operationId":"POST-customer-tenant-import-customers","tags":["Import and migration"],"description":"Imports multiple customer profiles in a single request. The maximum batch size is 200.\n\nEach item must include an `account` object with exactly one of:\n* `passwordHash` — a precomputed password hash compatible with the Emporix password hashing strategy. In order to determine if your existing strategy is compatible, please contact Emporix support.\n* `legacyAuth` — a legacy password hash (incompatible with the Emporix password hashing strategy) and algorithm metadata for lazy rehash on first successful login. In order to establish the required algorithm metadata for your case, please contact Emporix support.\n\nTo avoid indefinite storage of potentially sensitive legacy password hashes, importing customers with `legacyAuth` requires an active password migration retention configuration for the tenant.\n\nResponse for a particular customer is returned at the same position (index) at which that customer is located in the request body.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"array","maxItems":200,"items":{"$ref":"#/components/schemas/CustomerImportDto"}}}}},"responses":{"207":{"description":"Multi-Status","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CustomerBulkItemResponse"}}}}},"400":{"$ref":"#/components/responses/400_bad_request"},"401":{"$ref":"#/components/responses/401_unauthorized"},"403":{"$ref":"#/components/responses/403_forbidden"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.emporix.io/api-documentation/api-guides/companies-and-customers/customer-service/api-reference/import-and-migration.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
